#ifndef _DATA_H
#define _DATA_H

#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include "tools.h"
#include "assert.h"

#define MAX 1000000
#define SPLIT_NUM 2
#define BIT_LEN 1000
#define BIT_DISTANCE 1

//#define DEBUG

using namespace std;

struct fiCompare
{
	bool operator()(const bitset<BIT_LEN>& a, const bitset<BIT_LEN>& b) const
	{
		int i;
		for(i = BIT_LEN - 1; i >= 0; i--)
		{
			if((a.test(i) == true) && (b.test(i) == false))
			
				return false;
			
			else if ((a.test(i) == false) && (b.test(i) == true))
				return true;
				
		}
			return false;
	}
};

class FI
{
private:
	map<int, int> o_Mapping_r;   // original mapped to reduced;
	map<int, int> r_Mapping_o;   // reduced mapped to original;
	map<int, bitset<BIT_LEN> > FI_map;        // fi_mfi;
	set<bitset<BIT_LEN>,  fiCompare> FI_set;  // fi_mfi;

public:
	FI(const vector<vector<int> > fi_mfi_vector, const vector<vector<int> > mfi_vector); 
	~FI();
	void reduce(vector<vector<int> > fi_vector);
	map<int, bitset<BIT_LEN> >& getFI_map();
	set<bitset<BIT_LEN>, fiCompare>& getFI_set();
	map<int, int>& get_rmapo();
	map<int, int>& get_omapr();
};

 //based on FI, construct A, B, M;
class itemset_construct
{
private:
	vector<int> A;   // set A in biclique;
	vector<int> B;   // set B in biclique;
	vector<bitset<BIT_LEN> > M;   // maximal FI;

public:
	itemset_construct();
	~itemset_construct();
	void construct_A(map<int, bitset<BIT_LEN> > &FI_map);
	void construct_B(map<int, bitset<BIT_LEN> > &FI_map);
	void construct_M(vector<vector<int> > MFI_vector, map<int, int> mapping);
	vector<int>& get_A();
	vector<int>& get_B();
	vector<bitset<BIT_LEN> >& get_M();
};


//// based on itemset_construct, create a bipartite graph DB;
class bipartite_graph
{
private:
	vector<set<int> > DB;
	map<int, set<int> > DB_covered;

public:
	bipartite_graph();
	~bipartite_graph();
	vector<vector<int> > construct_graph(map<int, bitset<BIT_LEN> >& FI_map, set<bitset<BIT_LEN>, fiCompare >& FI_set, vector<int>& A, vector<int>& B, vector<bitset<BIT_LEN> >& M, char* Option);
	void write_FI_DB(vector<vector<int> > file_content, char* fileAddress);
	map<int,set<int> >& get_DB_covered();
	vector<set<int> >& get_DB();
};

#endif
