#include <fstream>
#include <iostream>
#include <string>
#include <vector>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <set>

using namespace std;

struct setCompare
{
	bool operator()(const set<int>& a, const set<int>& b) const
	{
		if(a.size() < b.size())
		{
			return true;
		}else if(a.size() > b.size())
		{
			return false;
		}else
		{
			set<int> t1 = a, t2 = b;
			set<int>::iterator it1, it2;
			while(t1.size() != 0 && t2.size() != 0)
			{
				it1 = t1.begin();
				it2 = t2.begin();
				if((*it1) < (*it2))
				{
					return true;
				}else if((*it1) > (*it2))
				{
					return false;
				}else
				{
					t1.erase(it1);
					t2.erase(it2);
				}
			}
			return false;
		}
	}
};

struct biclique
{
	set<set<int>, setCompare> a;
	set<set<int>, setCompare> b;
};

static void check(string Dir) {
	DIR *dp;
	if ((dp = opendir(Dir.c_str())) == NULL)
	{
		cout<<"Can not open?"<<endl;
		cout << "Error(" << errno << ") opening " << Dir << endl;
		return;
	}
	closedir(dp);
}

static void parse(string dir_addr0, string dir_addr1, string objective_addr) 
{
	DIR *dp;
	struct dirent *dirp;
	dp = opendir(dir_addr0.c_str());
	string line;
	char* number;

	string result = objective_addr;
	result += "statistics.dat";
	int count = 0;
	while ((dirp = readdir(dp)) != NULL) 
	{
		vector<biclique> bil;
	    set<set<int>, setCompare> distinct_set_a;
		set<set<int>, setCompare> distinct_set_b;
		string pathstr(dirp->d_name);
		if(!strcmp(pathstr.c_str(), ".") || !strcmp(pathstr.c_str(), ".."))
		{
			continue;
		}

		fstream fs1, fs2 ,fs3;
		fs1.open((dir_addr0 + pathstr).c_str());
		cout<<dir_addr0 + pathstr<<endl;		
		int cost = 0;                                         // for item size;
		int item_length = 0;                                  // for items of items size;
		while(!fs1.eof())                                       // read the biclique;
		{
			biclique temp;
			getline(fs1, line); 
			//cout<<line<<endl;
			if(line.size() == 0)                              // at the end of the file, there is always a zero-length charactor;
			{
				break;
			}

			int split = line.find(":");
			string a(line.begin(), line.begin() + split);     // for a;
			string b(line.begin() + split + 1, line.end());   // for b;

			while(strcmp(a.c_str(), " "))
			{
				set<int> tmp_set;
				set<int>::iterator tmpit;
				int split_position = a.find_first_of(",");
				string item = a.substr(0, split_position);
				a.erase(a.begin(), a.begin() + split_position + 1);
				char* c_item = new char[item.size() + 1];
				strcpy(c_item, item.c_str());
				number = strtok(c_item, " ");                   // get the first number;
			    while(number != NULL)
				{
					tmp_set.insert(atoi(number));
					number = strtok (NULL, " ");               // get other numbers;
				}
				 //for(tmpit = tmp_set.begin(); tmpit != tmp_set.end(); tmpit++)
				 //{
				 //	cout<<(*tmpit)<<" ";
				 //}
				/* cout<<endl;*/
				temp.a.insert(tmp_set);
				item_length += tmp_set.size();
				distinct_set_a.insert(tmp_set);
				cost++;
			}

			while(strcmp(b.c_str()," "))
			{
				set<int> tmp_set;
				set<int>::iterator tmpit;
				int split_position = b.find_first_of(",");
				string item = b.substr(0, split_position);
				b.erase(b.begin(), b.begin() + split_position + 1);
				char* c_item = new char[item.size() + 1];
				strcpy(c_item, item.c_str());
				number = strtok(c_item, " ");                  // get the first number;
			    while(number != NULL)
				{
					tmp_set.insert(atoi(number));
					number = strtok (NULL, " ");            // get other numbers;
				}
			/*	for(tmpit = tmp_set.begin(); tmpit != tmp_set.end(); tmpit++)
				{
					cout<<(*tmpit)<<" ";
				}*/
				//cout<<endl;
				temp.b.insert(tmp_set);
				item_length += tmp_set.size();
				distinct_set_b.insert(tmp_set);
				/*cout<<distinct_set_b.size()<<endl;*/
				cost++;
			}
			bil.push_back(temp);
		}
		fs1.close();


		//for(int i = 0; i < bil.size(); i++)
		//{
		//	set<set<int>, setCompare>::iterator it;
		//	for(it = bil[i].a.begin(); it != bil[i].a.end(); it++)
		//	{
		//		set<int>::iterator iit;
		//		for(iit = (*it).begin(); iit != (*it).end(); iit++)
		//		{
		//			cout<<(*iit)<<" ";
		//		}
		//		cout<<", ";
		//	}
		//	cout<<":";
		//	for(it = bil[i].b.begin(); it != bil[i].b.end(); it++)
		//	{
		//		set<int>::iterator iit;
		//		for(iit = (*it).begin(); iit != (*it).end(); iit++)
		//		{
		//			cout<<(*iit)<<" ";
		//		}
		//		cout<<", ";
		//	}
		//	cout<<endl;
		//}

	/*	set<set<int>, setCompare>::iterator it;
		for(it = distinct_set_a.begin(); it != distinct_set_a.end(); it++)
		{
			set<int>::iterator iit;
			for(iit = (*it).begin(); iit != (*it).end(); iit++)
			{
				cout<<(*iit)<<" ";
			}
			cout<<endl;;
		}
		cout<<distinct_set_a.size()<<endl;

		for(it = distinct_set_b.begin(); it != distinct_set_b.end(); it++)
		{
			set<int>::iterator iit;
			for(iit = (*it).begin(); iit != (*it).end(); iit++)
			{
				cout<<(*iit)<<" ";
			}
			cout<<endl;;
		}*/
		int title_length = pathstr.find_last_of(".");
		string title = pathstr.substr(0, title_length);
		fs2.open((dir_addr1 + pathstr).c_str());
		getline(fs2,line);                                       // read parameters;
		fs2.close();
		fs3.open(result.c_str(), fstream::out|fstream::app);
		fs3<<line<<endl;
		fs3<<title<<"\t: |Biclique| =\t"<<bil.size()<<"\t|ALL itemsets| =\t"<<item_length<<"\t|COST| =\t"<<cost<<"\t|Distinct items| =\t"<<distinct_set_a.size() + distinct_set_b.size()<<endl;
		fs3.close();
	}
	closedir(dp);
}

int main(int argc, char* argv[])
{
	if (argc < 2) {
		cerr << "\nUsage:\n" 
			 "\t./parse dataset_name"
			<< endl;
		return -1;
	}

	string dir_addr("result/");
	string tmp = argv[1];
	tmp.erase((int)tmp.find("."));
	dir_addr += tmp;
	dir_addr += "/";
	string dir_addr1 = dir_addr;
	string dir_addr0 = dir_addr;
	dir_addr0 += "biclique/";
	dir_addr1 += "parameter/";



	check(dir_addr0); // check the biclique directory exist or not;
	check(dir_addr1); // check the parameter directory too;
	parse(dir_addr0, dir_addr1, dir_addr);	// now parse the file;
	return 0;
}		

